Commit d644437a authored by Orson Zhai's avatar Orson Zhai Committed by Shuah Khan
Browse files

tools/testing/selftests/sysctl: Add pre-check to the value of writes_strict



Sysctl test will fail in some items if the value of /proc/sys/kernel
/sysctrl_writes_strict is 0 as the default value in kernel older than v4.5.

Make this test more robus and compatible with older kernel by checking and
update writes_strict value and restore it when test is done.

Signed-off-by: default avatarOrson Zhai <orson.zhai@linaro.org>
Reviewed-by: default avatarSumit Semwal <sumit.semwal@linaro.org>
Tested-by: default avatarSumit Semwal <sumit.semwal@linaro.org>
Reviewed-by: default avatarKees Cook <keescook@chromium.org>
Signed-off-by: default avatarShuah Khan <shuahkh@osg.samsung.com>
parent fde662d9
Loading
Loading
Loading
Loading
+22 −0
Original line number Diff line number Diff line
@@ -24,6 +24,14 @@ verify()
	return 0
}

exit_test()
{
	if [ ! -z ${old_strict} ]; then
		echo ${old_strict} > ${WRITES_STRICT}
	fi
	exit $rc
}

trap 'set_orig; rm -f "${TEST_FILE}"' EXIT

rc=0
@@ -63,6 +71,20 @@ else
	echo "ok"
fi

echo -n "Checking write strict setting ... "
WRITES_STRICT="${SYSCTL}/kernel/sysctl_writes_strict"
if [ ! -e ${WRITES_STRICT} ]; then
	echo "FAIL, but skip in case of old kernel" >&2
else
	old_strict=$(cat ${WRITES_STRICT})
	if [ "$old_strict" = "1" ]; then
		echo "ok"
	else
		echo "FAIL, strict value is 0 but force to 1 to continue" >&2
		echo "1" > ${WRITES_STRICT}
	fi
fi

# Now that we've validated the sanity of "set_test" and "set_orig",
# we can use those functions to set starting states before running
# specific behavioral tests.
+1 −1
Original line number Diff line number Diff line
@@ -7,4 +7,4 @@ TEST_STR=$(( $ORIG + 1 ))

. ./common_tests

exit $rc
exit_test
+1 −1
Original line number Diff line number Diff line
@@ -74,4 +74,4 @@ else
	echo "ok"
fi

exit $rc
exit_test